diff -ruN vdr-1.3.37/svdrp.c vdr-1.3.38/svdrp.c
--- vdr-1.3.37/svdrp.c	2005-11-27 16:29:28.000000000 +0100
+++ vdr-1.3.38/svdrp.c	2005-12-30 16:42:29.000000000 +0100
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 1.84 2005/11/27 15:29:28 kls Exp $
+ * $Id: svdrp.c 1.89 2005/12/30 15:42:29 kls Exp $
  */
 
 #include "svdrp.h"
@@ -201,10 +201,16 @@
   "    Edit the recording with the given number. Before a recording can be\n"
   "    edited, an LSTR command must have been executed in order to retrieve\n"
   "    the recording numbers.",
-  "GRAB <filename> [ jpeg | pnm [ <quality> [ <sizex> <sizey> ] ] ]\n"
+  "GRAB <filename> [ <quality> [ <sizex> <sizey> ] ]\n"
   "    Grab the current frame and save it to the given file. Images can\n"
-  "    be stored as JPEG (default) or PNM, at the given quality (default\n"
-  "    is 'maximum', only applies to JPEG) and size (default is full screen).",
+  "    be stored as JPEG or PNM, depending on the given file name extension.\n"
+  "    The quality of the grabbed image can be in the range 0..100, where 100\n"
+  "    (the default) means \"best\" (only applies to JPEG). The size parameters\n"
+  "    define the size of the resulting image (default is full screen).\n"
+  "    If the file name is just an extension (.jpg, .jpeg or .pnm) the image\n"
+  "    data will be sent to the SVDRP connection encoded in base64. The same\n"
+  "    happens if '-' (a minus sign) is given as file name, in which case the\n"
+  "    image format defaults to JPEG.",
   "HELP [ <topic> ]\n"
   "    The HELP command gives help info.",
   "HITK [ <key> ]\n"
@@ -307,6 +313,7 @@
 
  214 Help message
  215 EPG or recording data record
+ 216 Image grab data (base 64)
  220 VDR service ready
  221 VDR service closing transmission channel
  250 Requested VDR action okay, completed
@@ -354,6 +361,8 @@
   return NULL;
 }
 
+char *cSVDRP::grabImageDir = NULL;
+
 cSVDRP::cSVDRP(int Port)
 :socket(Port)
 {
@@ -656,36 +665,54 @@
      const char *delim = " \t";
      char *strtok_next;
      FileName = strtok_r(p, delim, &strtok_next);
-     if ((p = strtok_r(NULL, delim, &strtok_next)) != NULL) {
-        if (strcasecmp(p, "JPEG") == 0)
+     // image type:
+     char *Extension = strrchr(FileName, '.');
+     if (Extension) {
+        if (strcasecmp(Extension, ".jpg") == 0 || strcasecmp(Extension, ".jpeg") == 0)
            Jpeg = true;
-        else if (strcasecmp(p, "PNM") == 0)
+        else if (strcasecmp(Extension, ".pnm") == 0)
            Jpeg = false;
         else {
-           Reply(501, "Unknown image type \"%s\"", p);
+           Reply(501, "Unknown image type \"%s\"", Extension + 1);
            return;
            }
+        if (Extension == FileName)
+           FileName = NULL;
+        }
+     else if (strcmp(FileName, "-") == 0)
+        FileName = NULL;
+     else {
+        Reply(501, "Missing filename extension in \"%s\"", FileName);
+        return;
         }
+     // image quality (and obsolete type):
      if ((p = strtok_r(NULL, delim, &strtok_next)) != NULL) {
-        if (isnumber(p))
-           Quality = atoi(p);
-        else {
-           Reply(501, "Illegal quality \"%s\"", p);
-           return;
+        if (strcasecmp(p, "JPEG") == 0 || strcasecmp(p, "PNM") == 0) {
+           // tolerate for backward compatibility
+           p = strtok_r(NULL, delim, &strtok_next);
+           }
+        if (p) {
+           if (isnumber(p))
+              Quality = atoi(p);
+           else {
+              Reply(501, "Invalid quality \"%s\"", p);
+              return;
+              }
            }
         }
+     // image size:
      if ((p = strtok_r(NULL, delim, &strtok_next)) != NULL) {
         if (isnumber(p))
            SizeX = atoi(p);
         else {
-           Reply(501, "Illegal sizex \"%s\"", p);
+           Reply(501, "Invalid sizex \"%s\"", p);
            return;
            }
         if ((p = strtok_r(NULL, delim, &strtok_next)) != NULL) {
            if (isnumber(p))
               SizeY = atoi(p);
            else {
-              Reply(501, "Illegal sizey \"%s\"", p);
+              Reply(501, "Invalid sizey \"%s\"", p);
               return;
               }
            }
@@ -698,8 +725,67 @@
         Reply(501, "Unexpected parameter \"%s\"", p);
         return;
         }
-     if (cDevice::PrimaryDevice()->GrabImage(FileName, Jpeg, Quality, SizeX, SizeY))
-        Reply(250, "Grabbed image %s", Option);
+     // canonicalize the file name:
+     char RealFileName[PATH_MAX];
+     if (FileName) {
+        if (grabImageDir) {
+           char *s;
+           asprintf(&s, "%s/%s", grabImageDir, FileName);
+           FileName = s;
+           char *slash = strrchr(FileName, '/'); // there definitely is one
+           *slash = 0;
+           char *r = realpath(FileName, RealFileName);
+           *slash = '/';
+           if (!r) {
+              LOG_ERROR_STR(FileName);
+              Reply(501, "Invalid file name \"%s\"", FileName);
+              free(s);
+              return;
+              }
+           strcat(RealFileName, slash);
+           FileName = RealFileName;
+           free(s);
+           if (strncmp(FileName, grabImageDir, strlen(grabImageDir)) != 0) {
+              Reply(501, "Invalid file name \"%s\"", FileName);
+              return;
+              }
+           }
+        else {
+           Reply(550, "Grabbing to file not allowed (use \"GRAB -\" instead)");
+           return;
+           }
+        }
+     // actual grabbing:
+     int ImageSize;
+     uchar *Image = cDevice::PrimaryDevice()->GrabImage(ImageSize, Jpeg, Quality, SizeX, SizeY);
+     if (Image) {
+        if (FileName) {
+           int fd = open(FileName, O_WRONLY | O_CREAT | O_NOFOLLOW | O_TRUNC, DEFFILEMODE);
+           if (fd >= 0) {
+              if (safe_write(fd, Image, ImageSize) == ImageSize) {
+                 isyslog("grabbed image to %s", FileName);
+                 Reply(250, "Grabbed image %s", Option);
+                 }
+              else {
+                 LOG_ERROR_STR(FileName);
+                 Reply(451, "Can't write to '%s'", FileName);
+                 }
+              close(fd);
+              }
+           else {
+              LOG_ERROR_STR(FileName);
+              Reply(451, "Can't open '%s'", FileName);
+              }
+           }
+        else {
+           cBase64Encoder Base64(Image, ImageSize);
+           const char *s;
+           while ((s = Base64.NextLine()) != NULL)
+                 Reply(-216, s);
+           Reply(216, "Grabbed image %s", Option);
+           }
+        free(Image);
+        }
      else
         Reply(451, "Grab image failed");
      }
@@ -1482,4 +1568,10 @@
   return false;
 }
 
+void cSVDRP::SetGrabImageDir(const char *GrabImageDir)
+{
+  free(grabImageDir);
+  grabImageDir = GrabImageDir ? strdup(GrabImageDir) : NULL;
+}
+
 //TODO more than one connection???
diff -ruN vdr-1.3.37/svdrp.h vdr-1.3.38/svdrp.h
--- vdr-1.3.37/svdrp.h	2005-11-27 16:26:42.000000000 +0100
+++ vdr-1.3.38/svdrp.h	2005-12-30 15:46:38.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: svdrp.h 1.26 2005/11/27 15:26:42 kls Exp $
+ * $Id: svdrp.h 1.27 2005/12/30 14:46:38 kls Exp $
  */
 
 #ifndef __SVDRP_H
@@ -49,6 +49,7 @@
   int length;
   char *cmdLine;
   time_t lastActivity;
+  static char *grabImageDir;
   void Close(bool Timeout = false);
   bool Send(const char *s, int length = -1);
   void Reply(int Code, const char *fmt, ...) __attribute__ ((format (printf, 3, 4)));
@@ -87,6 +88,7 @@
   ~cSVDRP();
   bool HasConnection(void) { return file.IsOpen(); }
   bool Process(void);
+  static void SetGrabImageDir(const char *GrabImageDir);
   };
 
 #endif //__SVDRP_H
diff -ruN vdr-1.3.37/thread.c vdr-1.3.38/thread.c
--- vdr-1.3.37/thread.c	2005-11-27 16:15:53.000000000 +0100
+++ vdr-1.3.38/thread.c	2006-01-04 16:01:22.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.c 1.46 2005/11/27 15:15:53 kls Exp $
+ * $Id: thread.c 1.50 2006/01/04 15:01:22 kls Exp $
  */
 
 #include "thread.h"
@@ -12,6 +12,7 @@
 #include <malloc.h>
 #include <stdarg.h>
 #include <sys/resource.h>
+#include <sys/syscall.h>
 #include <sys/time.h>
 #include <sys/wait.h>
 #include <unistd.h>
@@ -136,7 +137,9 @@
 
 cRwLock::cRwLock(bool PreferWriter)
 {
-  pthread_rwlockattr_t attr = { PreferWriter ? PTHREAD_RWLOCK_PREFER_WRITER_NP : PTHREAD_RWLOCK_PREFER_READER_NP };
+  pthread_rwlockattr_t attr;
+  pthread_rwlockattr_init(&attr);
+  pthread_rwlockattr_setkind_np(&attr, PreferWriter ? PTHREAD_RWLOCK_PREFER_WRITER_NP : PTHREAD_RWLOCK_PREFER_READER_NP);
   pthread_rwlock_init(&rwlock, &attr);
 }
 
@@ -170,7 +173,9 @@
 cMutex::cMutex(void)
 {
   locked = 0;
-  pthread_mutexattr_t attr = { PTHREAD_MUTEX_ERRORCHECK_NP };
+  pthread_mutexattr_t attr;
+  pthread_mutexattr_init(&attr);
+  pthread_mutexattr_settype(&attr, PTHREAD_MUTEX_ERRORCHECK_NP);
   pthread_mutex_init(&mutex, &attr);
 }
 
@@ -193,13 +198,14 @@
 
 // --- cThread ---------------------------------------------------------------
 
-tThreadId cThread::mainThreadId = cThread::ThreadId();
+tThreadId cThread::mainThreadId = 0;
 bool cThread::emergencyExitRequested = false;
 
 cThread::cThread(const char *Description)
 {
   active = running = false;
   childTid = 0;
+  childThreadId = 0;
   description = NULL;
   SetDescription(Description);
 }
@@ -230,11 +236,12 @@
 
 void *cThread::StartThread(cThread *Thread)
 {
+  Thread->childThreadId = ThreadId();
   if (Thread->description)
-     dsyslog("%s thread started (pid=%d, tid=%ld)", Thread->description, getpid(), pthread_self());
+     dsyslog("%s thread started (pid=%d, tid=%d)", Thread->description, getpid(), Thread->childThreadId);
   Thread->Action();
   if (Thread->description)
-     dsyslog("%s thread ended (pid=%d, tid=%ld)", Thread->description, getpid(), pthread_self());
+     dsyslog("%s thread ended (pid=%d, tid=%d)", Thread->description, getpid(), Thread->childThreadId);
   Thread->running = false;
   Thread->active = false;
   return NULL;
@@ -292,7 +299,7 @@
                return;
             cCondWait::SleepMs(10);
             }
-        esyslog("ERROR: thread %ld won't end (waited %d seconds) - canceling it...", childTid, WaitSeconds);
+        esyslog("ERROR: thread %d won't end (waited %d seconds) - canceling it...", childThreadId, WaitSeconds);
         }
      pthread_cancel(childTid);
      childTid = 0;
@@ -308,6 +315,21 @@
   return emergencyExitRequested = true; // yes, it's an assignment, not a comparison!
 }
 
+_syscall0(pid_t, gettid)
+
+tThreadId cThread::ThreadId(void)
+{
+  return gettid();
+}
+
+void cThread::SetMainThreadId(void)
+{
+  if (mainThreadId == 0)
+     mainThreadId = ThreadId();
+  else
+     esyslog("ERROR: attempt to set main thread id to %d while it already is %d", ThreadId(), mainThreadId);
+}
+
 // --- cMutexLock ------------------------------------------------------------
 
 cMutexLock::cMutexLock(cMutex *Mutex)
diff -ruN vdr-1.3.37/thread.h vdr-1.3.38/thread.h
--- vdr-1.3.37/thread.h	2005-11-27 16:16:50.000000000 +0100
+++ vdr-1.3.38/thread.h	2006-01-08 12:40:23.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.h 1.32 2005/11/27 15:16:50 kls Exp $
+ * $Id: thread.h 1.36 2006/01/08 11:40:23 kls Exp $
  */
 
 #ifndef __THREAD_H
@@ -72,7 +72,7 @@
   void Unlock(void);
   };
 
-typedef pthread_t tThreadId;
+typedef pid_t tThreadId;
 
 class cThread {
   friend class cThreadLock;
@@ -80,6 +80,7 @@
   bool active;
   bool running;
   pthread_t childTid;
+  tThreadId childThreadId;
   cMutex mutex;
   char *description;
   static tThreadId mainThreadId;
@@ -106,7 +107,7 @@
   cThread(const char *Description = NULL);
        ///< Creates a new thread.
        ///< If Description is present, a log file entry will be made when
-       ///< the thread starts and stops. The Start() function must be called 
+       ///< the thread starts and stops. The Start() function must be called
        ///< to actually start the thread.
   virtual ~cThread();
   void SetDescription(const char *Description, ...) __attribute__ ((format (printf, 2, 3)));
@@ -115,8 +116,9 @@
   bool Active(void);
        ///< Checks whether the thread is still alive.
   static bool EmergencyExit(bool Request = false);
-  static tThreadId ThreadId(void) { return pthread_self(); }
+  static tThreadId ThreadId(void);
   static tThreadId IsMainThread(void) { return ThreadId() == mainThreadId; }
+  static void SetMainThreadId(void);
   };
 
 // cMutexLock can be used to easily set a lock on mutex and make absolutely
diff -ruN vdr-1.3.37/timers.c vdr-1.3.38/timers.c
--- vdr-1.3.37/timers.c	2005-09-09 17:22:33.000000000 +0200
+++ vdr-1.3.38/timers.c	2006-01-08 12:40:29.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: timers.c 1.36 2005/09/09 15:22:33 kls Exp $
+ * $Id: timers.c 1.41 2006/01/08 11:40:29 kls Exp $
  */
 
 #include "timers.h"
@@ -20,14 +20,14 @@
 
 // -- cTimer -----------------------------------------------------------------
 
-cTimer::cTimer(bool Instant, bool Pause)
+cTimer::cTimer(bool Instant, bool Pause, cChannel *Channel)
 {
   startTime = stopTime = 0;
   recording = pending = inVpsMargin = false;
   flags = tfNone;
   if (Instant)
      SetFlags(tfActive | tfInstant);
-  channel = Channels.GetByNumber(cDevice::CurrentChannel());
+  channel = Channel ? Channel : Channels.GetByNumber(cDevice::CurrentChannel());
   time_t t = time(NULL);
   struct tm tm_r;
   struct tm *now = localtime_r(&t, &tm_r);
@@ -110,7 +110,7 @@
   char *buffer;
   strreplace(file, ':', '|');
   strreplace(summary, '\n', '|');
-  asprintf(&buffer, "%d:%s:%s:%04d:%04d:%d:%d:%s:%s\n", flags, UseChannelID ? *Channel()->GetChannelID().ToString() : *itoa(Channel()->Number()), *PrintDay(day, weekdays), start, stop, priority, lifetime, file, summary ? summary : "");
+  asprintf(&buffer, "%u:%s:%s:%04d:%04d:%d:%d:%s:%s\n", flags, UseChannelID ? *Channel()->GetChannelID().ToString() : *itoa(Channel()->Number()), *PrintDay(day, weekdays), start, stop, priority, lifetime, file, summary ? summary : "");
   strreplace(summary, '|', '\n');
   strreplace(file, '|', ':');
   return cString(buffer, true);
@@ -244,7 +244,7 @@
      s = s2;
      }
   bool result = false;
-  if (8 <= sscanf(s, "%d :%a[^:]:%a[^:]:%d :%d :%d :%d :%a[^:\n]:%a[^\n]", &flags, &channelbuffer, &daybuffer, &start, &stop, &priority, &lifetime, &filebuffer, &summary)) {
+  if (8 <= sscanf(s, "%u :%a[^:]:%a[^:]:%d :%d :%d :%d :%a[^:\n]:%a[^\n]", &flags, &channelbuffer, &daybuffer, &start, &stop, &priority, &lifetime, &filebuffer, &summary)) {
      if (summary && !*skipspace(summary)) {
         free(summary);
         summary = NULL;
@@ -363,7 +363,7 @@
      }
 
   if (HasFlags(tfActive)) {
-     if (HasFlags(tfVps) && !Directly && event && event->Vps() && schedule && schedule->PresentSeenWithin(30)) {
+     if (HasFlags(tfVps) && !Directly && event && event->Vps() && event->Schedule() && event->Schedule()->PresentSeenWithin(30)) {
         startTime = event->StartTime();
         stopTime = event->EndTime();
         return event->IsRunning(true);
@@ -425,7 +425,7 @@
   return stopTime;
 }
 
-void cTimer::SetEvent(const cSchedule *Schedule, const cEvent *Event)
+void cTimer::SetEvent(const cEvent *Event)
 {
   if (event != Event) { //XXX TODO check event data, too???
      if (Event) {
@@ -436,7 +436,6 @@
         }
      else
         isyslog("timer %s set to no event", *ToDescr());
-     schedule = Event ? Schedule : NULL;
      event = Event;
      }
 }
@@ -463,22 +462,27 @@
   inVpsMargin = InVpsMargin;
 }
 
-void cTimer::SetFlags(int Flags)
+void cTimer::SetPriority(int Priority)
+{
+  priority = Priority;
+}
+
+void cTimer::SetFlags(uint Flags)
 {
   flags |= Flags;
 }
 
-void cTimer::ClrFlags(int Flags)
+void cTimer::ClrFlags(uint Flags)
 {
   flags &= ~Flags;
 }
 
-void cTimer::InvFlags(int Flags)
+void cTimer::InvFlags(uint Flags)
 {
   flags ^= Flags;
 }
 
-bool cTimer::HasFlags(int Flags) const
+bool cTimer::HasFlags(uint Flags) const
 {
   return (flags & Flags) == Flags;
 }
@@ -616,7 +620,7 @@
                             distance = e->EndTime() - now;
                          if (Event && overlap == Overlap) {
                             if (Overlap > FULLMATCH) { // this means VPS
-                               if (abs(Distance) < abs(distance)) 
+                               if (abs(Distance) < abs(distance))
                                   break; // we've already found the closest VPS event
                                }
                             else if (e->Duration() <= Event->Duration())
@@ -629,7 +633,7 @@
                       }
                   if (Event && Event->EndTime() < now - EXPIRELATENCY && !Event->IsRunning())
                      Event = NULL;
-                  ti->SetEvent(Schedule, Event);
+                  ti->SetEvent(Event);
                   }
                }
             }
diff -ruN vdr-1.3.37/timers.h vdr-1.3.38/timers.h
--- vdr-1.3.37/timers.h	2005-05-07 12:36:35.000000000 +0200
+++ vdr-1.3.38/timers.h	2006-01-06 15:13:17.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: timers.h 1.19 2005/05/07 10:36:35 kls Exp $
+ * $Id: timers.h 1.23 2006/01/06 14:13:17 kls Exp $
  */
 
 #ifndef __TIMERS_H
@@ -29,7 +29,7 @@
 private:
   mutable time_t startTime, stopTime;
   bool recording, pending, inVpsMargin;
-  int flags;
+  uint flags;
   cChannel *channel;
   mutable time_t day; ///< midnight of the day this timer shall hit, or of the first day it shall hit in case of a repeating timer
   int weekdays;       ///< bitmask, lowest bits: SSFTWTM  (the 'M' is the LSB)
@@ -39,10 +39,9 @@
   int lifetime;
   char file[MaxFileName];
   char *summary;
-  const cSchedule *schedule;
   const cEvent *event;
 public:
-  cTimer(bool Instant = false, bool Pause = false);
+  cTimer(bool Instant = false, bool Pause = false, cChannel *Channel = NULL);
   cTimer(const cEvent *Event);
   virtual ~cTimer();
   cTimer& operator= (const cTimer &Timer);
@@ -50,7 +49,7 @@
   bool Recording(void) const { return recording; }
   bool Pending(void) const { return pending; }
   bool InVpsMargin(void) const { return inVpsMargin; }
-  int Flags(void) const { return flags; }
+  uint Flags(void) const { return flags; }
   const cChannel *Channel(void) const { return channel; }
   time_t Day(void) const { return day; }
   int WeekDays(void) const { return weekdays; }
@@ -78,14 +77,15 @@
   bool Expired(void) const;
   time_t StartTime(void) const;
   time_t StopTime(void) const;
-  void SetEvent(const cSchedule *Schedule, const cEvent *Event);
+  void SetEvent(const cEvent *Event);
   void SetRecording(bool Recording);
   void SetPending(bool Pending);
   void SetInVpsMargin(bool InVpsMargin);
-  void SetFlags(int Flags);
-  void ClrFlags(int Flags);
-  void InvFlags(int Flags);
-  bool HasFlags(int Flags) const;
+  void SetPriority(int Priority);
+  void SetFlags(uint Flags);
+  void ClrFlags(uint Flags);
+  void InvFlags(uint Flags);
+  bool HasFlags(uint Flags) const;
   void Skip(void);
   void OnOff(void);
   cString PrintFirstDay(void) const;
diff -ruN vdr-1.3.37/tools.c vdr-1.3.38/tools.c
--- vdr-1.3.37/tools.c	2005-11-26 15:12:31.000000000 +0100
+++ vdr-1.3.38/tools.c	2006-01-08 12:40:35.000000000 +0100
@@ -4,13 +4,20 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 1.104 2005/11/26 14:12:31 kls Exp $
+ * $Id: tools.c 1.109 2006/01/08 11:40:35 kls Exp $
  */
 
 #include "tools.h"
 #include <ctype.h>
 #include <dirent.h>
 #include <errno.h>
+extern "C" {
+#ifdef boolean
+#define HAVE_BOOLEAN
+#endif
+#include <jpeglib.h>
+#undef boolean
+}
 #include <stdarg.h>
 #include <stdlib.h>
 #include <sys/time.h>
@@ -421,6 +428,42 @@
   return false;
 }
 
+int DirSizeMB(const char *DirName)
+{
+  cReadDir d(DirName);
+  if (d.Ok()) {
+     int size = 0;
+     struct dirent *e;
+     while (size >= 0 && (e = d.Next()) != NULL) {
+           if (strcmp(e->d_name, ".") && strcmp(e->d_name, "..")) {
+              char *buffer;
+              asprintf(&buffer, "%s/%s", DirName, e->d_name);
+              struct stat st;
+              if (stat(buffer, &st) == 0) {
+                 if (S_ISDIR(st.st_mode)) {
+                    int n = DirSizeMB(buffer);
+                    if (n >= 0)
+                       size += n;
+                    else
+                       size = -1;
+                    }
+                 else
+                    size += st.st_size / MEGABYTE(1);
+                 }
+              else {
+                 LOG_ERROR_STR(buffer);
+                 size = -1;
+                 }
+              free(buffer);
+              }
+           }
+     return size;
+     }
+  else
+     LOG_ERROR_STR(DirName);
+  return -1;
+}
+
 char *ReadLink(const char *FileName)
 {
   char RealName[PATH_MAX];
@@ -615,6 +658,145 @@
   return buf;
 }
 
+// --- RgbToJpeg -------------------------------------------------------------
+
+#define JPEGCOMPRESSMEM 500000
+
+struct tJpegCompressData {
+  int size;
+  uchar *mem;
+  };
+
+static void JpegCompressInitDestination(j_compress_ptr cinfo)
+{
+  tJpegCompressData *jcd = (tJpegCompressData *)cinfo->client_data;
+  if (jcd) {
+     cinfo->dest->free_in_buffer = jcd->size = JPEGCOMPRESSMEM;
+     cinfo->dest->next_output_byte = jcd->mem = MALLOC(uchar, jcd->size);
+     }
+}
+
+static boolean JpegCompressEmptyOutputBuffer(j_compress_ptr cinfo)
+{
+  tJpegCompressData *jcd = (tJpegCompressData *)cinfo->client_data;
+  if (jcd) {
+     int Used = jcd->size;
+     jcd->size += JPEGCOMPRESSMEM;
+     jcd->mem = (uchar *)realloc(jcd->mem, jcd->size);
+     if (jcd->mem) {
+        cinfo->dest->next_output_byte = jcd->mem + Used;
+        cinfo->dest->free_in_buffer = jcd->size - Used;
+        return TRUE;
+        }
+     }
+  return FALSE;
+}
+
+static void JpegCompressTermDestination(j_compress_ptr cinfo)
+{
+  tJpegCompressData *jcd = (tJpegCompressData *)cinfo->client_data;
+  if (jcd) {
+     int Used = cinfo->dest->next_output_byte - jcd->mem;
+     if (Used < jcd->size) {
+        jcd->size = Used;
+        jcd->mem = (uchar *)realloc(jcd->mem, jcd->size);
+        }
+     }
+}
+
+uchar *RgbToJpeg(uchar *Mem, int Width, int Height, int &Size, int Quality)
+{
+  if (Quality < 0)
+     Quality = 0;
+  else if (Quality > 100)
+     Quality = 100;
+
+  jpeg_destination_mgr jdm;
+
+  jdm.init_destination = JpegCompressInitDestination;
+  jdm.empty_output_buffer = JpegCompressEmptyOutputBuffer;
+  jdm.term_destination = JpegCompressTermDestination;
+
+  struct jpeg_compress_struct cinfo;
+  struct jpeg_error_mgr jerr;
+  cinfo.err = jpeg_std_error(&jerr);
+  jpeg_create_compress(&cinfo);
+  cinfo.dest = &jdm;
+  tJpegCompressData jcd;
+  cinfo.client_data = &jcd;
+  cinfo.image_width = Width;
+  cinfo.image_height = Height;
+  cinfo.input_components = 3;
+  cinfo.in_color_space = JCS_RGB;
+
+  jpeg_set_defaults(&cinfo);
+  jpeg_set_quality(&cinfo, Quality, true);
+  jpeg_start_compress(&cinfo, true);
+
+  int rs = Width * 3;
+  JSAMPROW rp[Height];
+  for (int k = 0; k < Height; k++)
+      rp[k] = &Mem[rs * k];
+  jpeg_write_scanlines(&cinfo, rp, Height);
+  jpeg_finish_compress(&cinfo);
+  jpeg_destroy_compress(&cinfo);
+
+  Size = jcd.size;
+  return jcd.mem;
+}
+
+// --- cBase64Encoder --------------------------------------------------------
+
+const char *cBase64Encoder::b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
+
+cBase64Encoder::cBase64Encoder(const uchar *Data, int Length, int MaxResult)
+{
+  data = Data;
+  length = Length;
+  maxResult = MaxResult;
+  i = 0;
+  result = MALLOC(char, maxResult + 1);
+}
+
+cBase64Encoder::~cBase64Encoder()
+{
+  free(result);
+}
+
+const char *cBase64Encoder::NextLine(void)
+{
+  int r = 0;
+  while (i < length && r < maxResult - 3) {
+        result[r++] = b64[(data[i] >> 2) & 0x3F];
+        char c = (data[i] << 4) & 0x3F;
+        if (++i < length)
+           c |= (data[i] >> 4) & 0x0F;
+        result[r++] = b64[c];
+        if (i < length) {
+           c = (data[i] << 2) & 0x3F;
+           if (++i < length)
+              c |= (data[i] >> 6) & 0x03;
+           result[r++] = b64[c];
+           }
+        else {
+           i++;
+           result[r++] = '=';
+           }
+        if (i < length) {
+           c = data[i] & 0x3F;
+           result[r++] = b64[c];
+           }
+        else
+           result[r++] = '=';
+        i++;
+        }
+  if (r > 0) {
+     result[r] = 0;
+     return result;
+     }
+  return NULL;
+}
+
 // --- cReadLine -------------------------------------------------------------
 
 cReadLine::cReadLine(void)
@@ -858,6 +1040,8 @@
 
 // --- cUnbufferedFile -------------------------------------------------------
 
+//#define USE_FADVISE
+
 #define READ_AHEAD MEGABYTE(2)
 #define WRITE_BUFFER MEGABYTE(10)
 
@@ -882,6 +1066,7 @@
 
 int cUnbufferedFile::Close(void)
 {
+#ifdef USE_FADVISE
   if (fd >= 0) {
      if (ahead > end)
         end = ahead;
@@ -894,6 +1079,7 @@
      begin = end = ahead = -1;
      written = 0;
      }
+#endif
   int OldFd = fd;
   fd = -1;
   return close(OldFd);
@@ -909,6 +1095,7 @@
 ssize_t cUnbufferedFile::Read(void *Data, size_t Size)
 {
   if (fd >= 0) {
+#ifdef USE_FADVISE
      off_t pos = lseek(fd, 0, SEEK_CUR);
      // jump forward - adjust end position
      if (pos > end)
@@ -922,7 +1109,9 @@
      if (begin >= 0 && end > begin)
         posix_fadvise(fd, begin - KILOBYTE(200), end - begin + KILOBYTE(200), POSIX_FADV_DONTNEED);//XXX macros/parameters???
      begin = pos;
+#endif
      ssize_t bytesRead = safe_read(fd, Data, Size);
+#ifdef USE_FADVISE
      if (bytesRead > 0) {
         pos += bytesRead;
         end = pos;
@@ -935,6 +1124,7 @@
         }
      else
         end = pos;
+#endif
      return bytesRead;
      }
   return -1;
@@ -943,8 +1133,11 @@
 ssize_t cUnbufferedFile::Write(const void *Data, size_t Size)
 {
   if (fd >=0) {
+#ifdef USE_FADVISE
      off_t pos = lseek(fd, 0, SEEK_CUR);
+#endif
      ssize_t bytesWritten = safe_write(fd, Data, Size);
+#ifdef USE_FADVISE
      if (bytesWritten >= 0) {
         written += bytesWritten;
         if (begin >= 0) {
@@ -964,6 +1157,7 @@
            written = 0;
            }
         }
+#endif
      return bytesWritten;
      }
   return -1;
@@ -1090,7 +1284,7 @@
 // --- cListBase -------------------------------------------------------------
 
 cListBase::cListBase(void)
-{ 
+{
   objects = lastObject = NULL;
   count = 0;
 }
@@ -1101,7 +1295,7 @@
 }
 
 void cListBase::Add(cListObject *Object, cListObject *After)
-{ 
+{
   if (After && After != lastObject) {
      After->Next()->Insert(Object);
      After->Append(Object);
@@ -1117,7 +1311,7 @@
 }
 
 void cListBase::Ins(cListObject *Object, cListObject *Before)
-{ 
+{
   if (Before && Before != objects) {
      Before->Prev()->Append(Object);
      Before->Insert(Object);
diff -ruN vdr-1.3.37/tools.h vdr-1.3.38/tools.h
--- vdr-1.3.37/tools.h	2005-11-26 15:03:47.000000000 +0100
+++ vdr-1.3.38/tools.h	2006-01-08 12:40:37.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.h 1.84 2005/11/26 14:03:47 kls Exp $
+ * $Id: tools.h 1.89 2006/01/08 11:40:37 kls Exp $
  */
 
 #ifndef __TOOLS_H
@@ -110,6 +110,7 @@
 bool MakeDirs(const char *FileName, bool IsDirectory = false);
 bool RemoveFileOrDir(const char *FileName, bool FollowSymlinks = false);
 bool RemoveEmptyDirectories(const char *DirName, bool RemoveThis = false);
+int DirSizeMB(const char *DirName); ///< returns the total size of the files in the given directory, or -1 in case of an error
 char *ReadLink(const char *FileName); ///< returns a new string allocated on the heap, which the caller must delete (or NULL in case of an error)
 bool SpinUpDisk(const char *FileName);
 void TouchFile(const char *FileName);
@@ -120,6 +121,39 @@
 cString TimeToString(time_t t);
 cString DateString(time_t t);
 cString TimeString(time_t t);
+uchar *RgbToJpeg(uchar *Mem, int Width, int Height, int &Size, int Quality = 100);
+    ///< Converts the given Memory to a JPEG image and returns a pointer
+    ///< to the resulting image. Mem must point to a data block of exactly
+    ///< (Width * Height) triplets of RGB image data bytes. Upon return, Size
+    ///< will hold the number of bytes of the resulting JPEG data.
+    ///< Quality can be in the range 0..100 and controls the quality of the
+    ///< resulting image, where 100 is "best". The caller takes ownership of
+    ///< the result and has to delete it once it is no longer needed.
+    ///< The result may be NULL in case of an error.
+
+class cBase64Encoder {
+private:
+  const uchar *data;
+  int length;
+  int maxResult;
+  int i;
+  char *result;
+  static const char *b64;
+public:
+  cBase64Encoder(const uchar *Data, int Length, int MaxResult = 64);
+      ///< Sets up a new base 64 encoder for the given Data, with the given Length.
+      ///< Data will not be copied and must be valid as long as NextLine() will be
+      ///< called. MaxResult defines the maximum number of characters in any
+      ///< result line. The resulting lines may be shorter than MaxResult in case
+      ///< its value is not a multiple of 4.
+  ~cBase64Encoder();
+  const char *NextLine(void);
+      ///< Returns the next line of encoded data (terminated by '\0'), or NULL if
+      ///< there is no more encoded data. The caller must call NextLine() and process
+      ///< each returned line until NULL is returned, in order to get the entire
+      ///< data encoded. The returned data is only valid until the next time NextLine()
+      ///< is called, or until the object is destroyed.
+  };
 
 class cTimeMs {
 private:
@@ -152,7 +186,7 @@
   bool Add(int FileHandle, bool Out);
   bool Poll(int TimeoutMs = 0);
   };
-  
+
 class cReadDir {
 private:
   DIR *directory;
